【矩阵二分】力扣378. 有序矩阵中第 K 小的元素

给你一个 n x n 矩阵 matrix ,其中每行和每列元素均按升序排序,找到矩阵中第 k 小的元素。

请注意,它是 排序后 的第 k 小元素,而不是第 k 个 不同 的元素。

你必须找到一个内存复杂度优于 O(n2) 的解决方案。

示例 1:

输入:matrix = \[1,5,9,10,11,13,12,13,15], k = 8

输出:13

解释:矩阵中的元素为 1,5,9,10,11,12,13,13,15,第 8 小元素是 13

示例 2:

输入:matrix = \[-5], k = 1

输出:-5

二分

csharp 复制代码
class Solution {
public:
    bool check(vector<vector<int>>& matrix, int mid, int k, int n){
        int i = n - 1;
        int j = 0;
        int num = 0;
        while(i >= 0 && j < n){
            if(matrix[i][j] <= mid){
                num += i + 1;
                j++;
            }
            else{
                i--;
            }
        }
        return k <= num;
    }


    int kthSmallest(vector<vector<int>>& matrix, int k) {
        int n = matrix.size();
        int left = matrix[0][0];
        int right = matrix[n-1][n-1];
        while(left < right){
            int mid = (left + right) >> 1;
            if(check(matrix, mid, k, n)){
                right = mid;
            }
            else{
                left = mid + 1;
            }
        }
        return left;
    }
};

时间复杂度:O(nlog(r−l)) ,二分查找进行次数为 O(log(r−l)),每次操作时间复杂度为 O(n)。
空间复杂度:O(1)。

矩阵中最小的元素是matrix00,最大的元素是matrixn-1n-1,这道题使用二分查找的思想就是我们从最小数到最大数之间任意挑一个数字作为mid。假设mid = 8,根据图片,矩阵可以分成两个部分,一个部分全部小于等于8,另外一个部分全部大于8。我们可以统计左上部分小于等于8的数的数量,看8在排序后是第几小的数(因为图片有多个8,所以返回的是8是第几小的数的最大情况,即升序排列中最右边的8的位置)。

所以在二分查找中,我们从取left + right除以2的值为mid,如果在check函数中得出来左上部分的数量大于等于我们所期待的k,那么就说明我们的取的mid大于等于实际元素,这时候我们就将right = mid,缩小他的上界。如果左上部分数量小于我们所期待的k,说明我们取的mid比实际元素要小,我们令left = mid + 1,增加他的下界。

很多人会疑问left怎么确保一定是矩阵中的数?

如题解中所说,如果 num >= k,那么说明最终答案 x <= mid;如果 num < k,那么说明最终答案 x > mid。 在最后一次迭代时,check返回的结果为false,即 num < k,说明 x > mid,又因为 x <= right。当 left = mid + 1 后,left >= righ,while循环结束。此时有 mid < x <= right <= left = mid + 1,即 mid < x <= mid + 1。可得 x = mid + 1 = left。

相关推荐
Pniubi7 小时前
力扣283移动零(双指针法)
算法·leetcode·职场和发展
旖旎夜光17 小时前
LeetCode 315: 算右侧小于当前元素的个数(归并排序) —— 题解
c++·学习·算法·leetcode·排序算法
文丑颜不良啊18 小时前
LeetCode1401~1420题目解析
java·leetcode
Nuanyt18 小时前
LeetCode Hot 100 链表专题2 3 题 (Java)
java·笔记·算法·leetcode·链表
文丑颜不良啊18 小时前
LeetCode1341~1360题目解析
java·leetcode
海绵宝宝转agent18 小时前
LeetCodehot100题解
java·笔记·学习·算法·leetcode·深度优先
Pniubi20 小时前
力扣543二叉树的直径(深度优先搜索法(递归))
算法·leetcode·职场和发展
j7~2 天前
【穷举、深搜与回溯算法】一棵决策树讲透全排列与子集
数据结构·c++·算法·leetcode·回溯·递归
Shaoshing2 天前
LeetCode100 42.接雨水
java·算法·leetcode
文丑颜不良啊2 天前
LeetCode1261~1280题目解析
java·leetcode